import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, HostListener, Input, Output, NgModule } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2 from '@angular/forms';
import { FormsModule } from '@angular/forms';

class NgxSuperSelectService {
    constructor() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: NgxSuperSelectService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: NgxSuperSelectService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: NgxSuperSelectService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class NgxSuperSelectOptions {
    constructor() {
        this.actionsEnabled = true;
        this.searchEnabled = true;
        this.placeholder = '';
        this.displayExpr = '';
        this.valueExpr = '';
    }
}
const NgxSuperSelectOptionsDefulats = {
    actionsEnabled: true,
    displayExpr: '',
    valueExpr: '',
    placeholder: 'Select',
    searchEnabled: true
};

class NgxSuperSelectComponent {
    constructor() {
        this.dataSource = [];
        this._options = NgxSuperSelectOptionsDefulats;
        this.selectedItemValues = [];
        this.selectionChanged = new EventEmitter();
        this.isOpen = false;
        this.searchText = '';
    }
    onDocumentClicked() {
        this.isOpen = false;
    }
    set options(value) {
        this._options = value;
    }
    ;
    get options() {
        return this._options;
    }
    onBoxClicked(e) {
        this.isOpen = !this.isOpen;
        e.stopPropagation();
        e.preventDefault();
        this.searchText = '';
    }
    onItemClicked(e, item) {
        e.stopPropagation();
        e.preventDefault();
        const index = this.selectedItemValues.findIndex(x => x === this.getValue(item));
        if (index < 0) {
            const a = [...this.selectedItemValues];
            a.push(this.getValue(item));
            this.selectedItemValues = a;
        }
        else {
            const a = [...this.selectedItemValues];
            a.splice(index, 1);
            this.selectedItemValues = a;
        }
        this.selectionChanged.emit(this.selectedItemValues);
    }
    onSelectAllClicked(e) {
        this.selectedItemValues = this.dataSource.map(x => this.getValue(x));
        this.handleActionButtonEvent(e);
    }
    onInvertSelectionClicked(e) {
        this.selectedItemValues = this.dataSource.filter(i => !this.isSelected(i)).map(x => this.getValue(x));
        this.handleActionButtonEvent(e);
    }
    onClearClicked(e) {
        this.selectedItemValues = [];
        this.handleActionButtonEvent(e);
    }
    handleActionButtonEvent(e) {
        e.stopPropagation();
        e.preventDefault();
        this.selectionChanged.emit(this.selectedItemValues);
    }
    onPopupClicked(e) {
        e.stopPropagation();
        e.preventDefault();
    }
    isSelected(item) {
        return this.selectedItemValues.findIndex(x => x === this.getValue(item)) >= 0;
    }
    getFilteredItems() {
        const val = this.searchText.trim().toLocaleLowerCase();
        if (val === '') {
            return this.dataSource;
        }
        else {
            return this.dataSource.filter(x => this.getName(x).toLocaleLowerCase().indexOf(val) >= 0);
        }
    }
    getName(obj) {
        return Object.getOwnPropertyDescriptors(obj)[this.options.displayExpr]?.value || obj;
    }
    getValue(obj) {
        return +Object.getOwnPropertyDescriptors(obj)[this.options.valueExpr]?.value || obj;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: NgxSuperSelectComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.0", type: NgxSuperSelectComponent, selector: "lib-ngx-super-select", inputs: { dataSource: "dataSource", options: "options", selectedItemValues: "selectedItemValues" }, outputs: { selectionChanged: "selectionChanged" }, host: { listeners: { "document:click": "onDocumentClicked()" } }, ngImport: i0, template: "<div class=\"select-box\"\r\n     [class.open]=\"isOpen\"\r\n     (click)=\"onBoxClicked($event)\">\r\n\r\n    <span>{{ options.placeholder }}</span>\r\n    <span *ngIf=\"selectedItemValues.length > 0\"\r\n          class=\"mx-2 text-danger\">{{ selectedItemValues.length }}</span>\r\n\r\n    <div class=\"select-popup\"\r\n         [class.open]=\"isOpen\"\r\n         (click)=\"onPopupClicked($event)\">\r\n\r\n        <div class=\"select-popup-control-panel\">\r\n            <div *ngIf=\"options.actionsEnabled\"\r\n                 class=\"actions\">\r\n                <button class=\"btn btn-outline-primary btn-sm\"\r\n                        (click)=\"onSelectAllClicked($event)\">\r\n                    All\r\n                </button>\r\n                <button class=\"btn btn-outline-primary btn-sm\"\r\n                        (click)=\"onInvertSelectionClicked($event)\">\r\n                    Invert\r\n                </button>\r\n                <button class=\"btn btn-outline-danger btn-sm\"\r\n                        (click)=\"onClearClicked($event)\">\r\n                    Clear\r\n                </button>\r\n            </div>\r\n\r\n            <hr *ngIf=\"options.actionsEnabled\">\r\n\r\n            <input *ngIf=\"options.searchEnabled\"\r\n                   type=\"text\"\r\n                   id=\"searchBox\"\r\n                   class=\"form-control form-control-sm mx-auto\"\r\n                   style=\"width: 95%;\"\r\n                   placeholder=\"search\"\r\n                   [(ngModel)]=\"searchText\"\r\n                   autocomplete=\"off\">\r\n\r\n            <hr *ngIf=\"options.searchEnabled\">\r\n        </div>\r\n\r\n        <div class=\"select-popup-options\">\r\n            <div *ngFor=\"let item of getFilteredItems()\"\r\n                 class=\"select-option\"\r\n                 [class.selected]=\"isSelected(item)\"\r\n                 (click)=\"onItemClicked($event, item)\">\r\n                {{ getName(item) }}\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>", styles: [".select-box{cursor:pointer;height:40px;border-radius:4px;border:1px solid gainsboro;position:relative;display:flex;align-items:center;padding-left:.5rem;padding-right:.2rem;transition-duration:.2s}.select-box>span{color:gray}.select-box.open{width:300px}.select-popup{position:absolute;display:none;background-color:#fff;padding:.5rem 0;box-shadow:0 0 2px 2px #d7d7d7;border-radius:4px;overflow:hidden}.select-popup hr{margin:.5rem}.select-popup.open{display:grid;grid-template-rows:auto 1fr;width:100%;max-height:400px;z-index:1000;position:absolute;top:100%;left:0}.select-popup .select-popup-control-panel{width:100%}.select-popup .select-popup-options{width:100%;grid-row:2;overflow-y:auto}.actions{display:flex;justify-content:space-evenly;align-items:center;gap:4px;width:100%}.select-option{-webkit-user-select:none;user-select:none;padding:1rem;width:100%;font-weight:500;font-size:1.2rem;cursor:pointer}.select-option.selected{position:relative;background-color:#f6f6f6}.select-option.selected:before{content:\" \";position:absolute;left:0;top:10%;display:inline-block;width:4px;height:80%;background-color:#767676}.select-option:hover{background-color:#e5e5e5}\n"], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: NgxSuperSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-ngx-super-select', template: "<div class=\"select-box\"\r\n     [class.open]=\"isOpen\"\r\n     (click)=\"onBoxClicked($event)\">\r\n\r\n    <span>{{ options.placeholder }}</span>\r\n    <span *ngIf=\"selectedItemValues.length > 0\"\r\n          class=\"mx-2 text-danger\">{{ selectedItemValues.length }}</span>\r\n\r\n    <div class=\"select-popup\"\r\n         [class.open]=\"isOpen\"\r\n         (click)=\"onPopupClicked($event)\">\r\n\r\n        <div class=\"select-popup-control-panel\">\r\n            <div *ngIf=\"options.actionsEnabled\"\r\n                 class=\"actions\">\r\n                <button class=\"btn btn-outline-primary btn-sm\"\r\n                        (click)=\"onSelectAllClicked($event)\">\r\n                    All\r\n                </button>\r\n                <button class=\"btn btn-outline-primary btn-sm\"\r\n                        (click)=\"onInvertSelectionClicked($event)\">\r\n                    Invert\r\n                </button>\r\n                <button class=\"btn btn-outline-danger btn-sm\"\r\n                        (click)=\"onClearClicked($event)\">\r\n                    Clear\r\n                </button>\r\n            </div>\r\n\r\n            <hr *ngIf=\"options.actionsEnabled\">\r\n\r\n            <input *ngIf=\"options.searchEnabled\"\r\n                   type=\"text\"\r\n                   id=\"searchBox\"\r\n                   class=\"form-control form-control-sm mx-auto\"\r\n                   style=\"width: 95%;\"\r\n                   placeholder=\"search\"\r\n                   [(ngModel)]=\"searchText\"\r\n                   autocomplete=\"off\">\r\n\r\n            <hr *ngIf=\"options.searchEnabled\">\r\n        </div>\r\n\r\n        <div class=\"select-popup-options\">\r\n            <div *ngFor=\"let item of getFilteredItems()\"\r\n                 class=\"select-option\"\r\n                 [class.selected]=\"isSelected(item)\"\r\n                 (click)=\"onItemClicked($event, item)\">\r\n                {{ getName(item) }}\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>", styles: [".select-box{cursor:pointer;height:40px;border-radius:4px;border:1px solid gainsboro;position:relative;display:flex;align-items:center;padding-left:.5rem;padding-right:.2rem;transition-duration:.2s}.select-box>span{color:gray}.select-box.open{width:300px}.select-popup{position:absolute;display:none;background-color:#fff;padding:.5rem 0;box-shadow:0 0 2px 2px #d7d7d7;border-radius:4px;overflow:hidden}.select-popup hr{margin:.5rem}.select-popup.open{display:grid;grid-template-rows:auto 1fr;width:100%;max-height:400px;z-index:1000;position:absolute;top:100%;left:0}.select-popup .select-popup-control-panel{width:100%}.select-popup .select-popup-options{width:100%;grid-row:2;overflow-y:auto}.actions{display:flex;justify-content:space-evenly;align-items:center;gap:4px;width:100%}.select-option{-webkit-user-select:none;user-select:none;padding:1rem;width:100%;font-weight:500;font-size:1.2rem;cursor:pointer}.select-option.selected{position:relative;background-color:#f6f6f6}.select-option.selected:before{content:\" \";position:absolute;left:0;top:10%;display:inline-block;width:4px;height:80%;background-color:#767676}.select-option:hover{background-color:#e5e5e5}\n"] }]
        }], propDecorators: { onDocumentClicked: [{
                type: HostListener,
                args: ['document:click']
            }], dataSource: [{
                type: Input
            }], options: [{
                type: Input
            }], selectedItemValues: [{
                type: Input
            }], selectionChanged: [{
                type: Output
            }] } });

class NgxSuperSelectModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: NgxSuperSelectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.0", ngImport: i0, type: NgxSuperSelectModule, declarations: [NgxSuperSelectComponent], imports: [CommonModule,
            FormsModule], exports: [NgxSuperSelectComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: NgxSuperSelectModule, imports: [CommonModule,
            FormsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.0", ngImport: i0, type: NgxSuperSelectModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NgxSuperSelectComponent
                    ],
                    imports: [
                        CommonModule,
                        FormsModule
                    ],
                    exports: [
                        NgxSuperSelectComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of ngx-super-select
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxSuperSelectComponent, NgxSuperSelectModule, NgxSuperSelectOptions, NgxSuperSelectOptionsDefulats, NgxSuperSelectService };
//# sourceMappingURL=ngx-super-select.mjs.map
